{smcl}
{* *! version 1.0  05 May 2009}{...}
{cmd:help aisa}
{hline}

{title:Title}

{p2colset 4 14 16 2}{...}
{p2col:{hi:aisa} {hline 2}}Automated individual student assessment{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 20 2}
{cmd:aisa} {opt rost:er} {it:project}
{cmd:using} {it:filename}
{cmd:,}
{opt seed(#)}
[
{opt idl:ength(#)}
{opt johndoe}
{opt last:first}
{opt replace}
{opt var:iables(string)}
]

{p 8 20 2}
{cmd:aisa} {opt list}

{p 8 20 2}
{cmd:aisa} {opt data}
{it:assignment}
[{cmd:,}
{opt ext:ernal(directory)}
{opt verb:ose}
]

{p 8 20 2}
{cmd:aisa} {opt keys}
{it:assignment}
[{cmd:,}
{opt replace}
{opt verb:ose}
]

{p 8 20 2}
{cmd:aisa} {opt check}
{it:assignment} [{it:IDlist}]
[{cmd:,}
{opt replace}
{opt verb:ose}
]

{p 16 16 16}
where {it:IDlist} is

{p 20 20 20}
{it:ID# }[{it:ID# ID# ...}] | {cmd:_all}

{p 8 20 2}
{cmd:aisa} {opt comp:ile}
[{cmd:,}
{opt replace}
]

{p 8 20 2}
{cmd:aisa} {opt upd:ate}
{it:assignment}

{p 8 20 2}
{cmd:aisa} {opt do}
{it:assignment prefix}
[{cmd:,}
{opt verb:ose}
]

{p 8 20 2}
{cmd:aisa} {opt irt}
{it:assignment}

{p 8 20 2}
{cmd:aisa} {opt upd:ate}
{it:assignment}

{p 8 20 2}
{cmd:aisa} {opt grad:ebook}
[{it:assignment}]
[{cmd:,}
{opt lastf:irst}
{opt nomis:sing}
{opt score:only}
]

{p 8 20 2}
{cmd:aisa} {opt look:up}
[ {it:ID#}|{it:Lastname} ]


{title:Description}

{pstd}{cmd:aisa roster} creates the student roster, assigns
random IDs to them and places the following working files
in the current directory:

{phang2}{cmd:aisa.dta} contains the settings defined as characteristics,
see {help char}.

{phang2}{it:project}{cmd:-roster.dta} contains the list of students
and their randomly generated {it:ID#}'s.

{phang2}{it:project}{cmd:-grades.dta} contains the grades.

{pstd}{cmd:aisa list} lists students by their course IDs.

{pstd}{cmd:aisa data} creates the data files
for the specified assignment. It requires that (i) a sub-directory
named {it:assignment} of the current directory exists,
and (ii) a do-file named {cmd:data-}{it:assignment}{cmd:.do}
exists in it. Files {cmd:data-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta}
are created in the subdirectory {it:assignment}.
See {help aisa##examples:Examples}.

{pstd}{cmd:aisa keys} generates the keys
for the specified assignment. It requires that (i) a sub-directory
named {it:assignment} of the current directory exists,
(ii) the assignment data files with names
{cmd:data-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta}
and (iii) that a do-file named {cmd:keys-}{it:assignment}{cmd:.do}
exist in it. Files {cmd:key-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta}
are created in the subdirectory {it:assignment}.

{pstd}{cmd:aisa check} grades the specified assignment.
It requires that (i) a sub-directory
named {it:assignment} of the current directory exists,
(ii) the key files named {cmd:keys-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta}
and (iii) the student answers named {cmd:keys-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta}
exist in it. It creates files {cmd:result-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta}
for the students whose assignments were available. See
{help aisa##files:File formats} below for additional information.

{pstd}{cmd:aisa compile} takes the output of {cmd:aisa check}
and compiles the results into
the file {cmd:results-}{it:assignment}{cmd:-long.dta}
for later use (e.g., in {cmd:aisa irt}.

{pstd}{cmd:aisa update} takes the output of {cmd:aisa check}
and: (i) puts them into the file
{it:assignment}{cmd:-results-wide.dta}; (ii) adds
variables {it:assignment}{cmd:_RawScore}, {it:assignment}{cmd:_AdjScore}
and {it:assignment}{cmd:_Missed} to the file
{it:project}{cmd:-grades.dta}; (iii) produces html file
with a rough table reporting student number,
the score, and the problems each student missed on the assignment.

{pstd}{cmd:aisa do} collects the list of files
{it:prefix}{cmd:*.do} in directory {it:assignment}
and runs them. That way, student submissions in do-file
format are processed.

{pstd}{cmd:aisa irt} runs {help xtmelogit} for
(an equivalent of) one-parameter IRT model, and updates
the {it:assignment}{cmd:_AdjScore} variable to contain
the empirical Bayes predictions of the latent random effects.

{pstd}{cmd:aisa gradebook} prints the gradebook for all
or selected assignments.

{pstd}{cmd:aisa lookup} find the student in
{it:project}{cmd:-grades.dta} and prints his or her grades.


{title:Options}

{pstd}Options are given for the alphabetically arranged subcommands.

{dlgtab:aisa check}

{phang}{opt replace} specifies that the existing files
{cmd:result-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta}
can be overwritten. In other words, this gives students
a resubmission opportunity.

{phang}{opt verb:ose} prints out the details of the assessment,
including the student's answers and and indicator variable showing
whether those are correct or not. Usually specified
when an individual student's submission is checked with
{cmd aisa check }{it:assignment ID#}.

{dlgtab:aisa compile}

{phang}{opt replace} specifies that the existing files
{cmd:result-}{it:assignment}{cmd:-long.dta}
can be overwritten.

{dlgtab:aisa data}

{phang}{opt external(directory)} gives an external directory
to copy the students data files
{cmd:data-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta},
such as instructor's webpage.

{phang}{opt verb:ose} shows output from instructor's
{cmd:data-}{it:assignment}{cmd:.do} files, and is used
for debugging purposes.

{dlgtab:aisa do}

{phang}{opt verb:ose} shows output from student submissions.

{dlgtab:aisa gradebook}

{phang}{opt last:first} specifies that the entries
are arranged alphabetically by the students' names.
The default sorting order is by the {cmd:CourseID} student number.

{phang}{opt nomiss:ing} suppresses listing the students
for whom a given {it:assignment} is missing.

{phang}{opt score:only} suppresses the output of
{it:assignment}{cmd:_Missed} variables that sometimes use a lot of space.

{dlgtab:aisa keys}

{phang}{opt replace} specifies that the existing files
{cmd:result-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta}
can be overwritten.

{phang}{opt verb:ose} shows output from instructor's
{cmd:key-}{it:assignment}{cmd:.do} files, and is used
for debugging purposes.

{dlgtab:aisa roster}

{phang}{opt idl:ength(#)} specifies the number of digits
in the randomly generated student {it:ID#}. The default value
is 6.

{phang}{opt johndoe} specifies that an extra record for
fictitious student is placed in the roster and grades files.
This student is given the name John Doe, and his {it:ID#}
is set to 10^{opt idlength}-1. Thus if the default length
of 6 digits is used, John Doe's ID will be 99999.

{phang}{opt last:first(varname)} gives the name of the variable
that contains the full name in the "lastname, firstname" format.
That variable is parsed, and the corresponding names are placed
into {cmd:LastName} and {cmd:FirstName} variables.

{phang}{opt replace} allows to replace the existing
files {cmd:aisa.dta}, {it:project}{cmd:-roster.dta}
and {it:project}{cmd:-roster.dta}.

{phang}{opt seed(#)} is the random seed.

{phang}{opt var:iables(varlist)} is the list of variables
in the {it:using} file.


{title:File formats}{marker files}

{pstd}{cmd:aisa} creates and works with the following files.

dta-files:

{phang}{cmd:aisa.dta} has zero observations, and has the following
characteristics describing the basic information about the current
project:

{phang2}{cmd:char _dta[name] }{it:project}

{phang2}{cmd:char _dta[seed] }{it:random seed used}

{phang2}{cmd:char _dta[dir] }{it:current directory}

{phang}This information is retrieved by all subcommands of {cmd:aisa}
except {cmd:aisa roster}.

{phang}{cmd:aisa-}{it:project}{cmd:-roster.dta} is the student roster
that contains, at the very least, variables {cmd:LastName} and {cmd:FirstName}
with student names, and {cmd:CourseID}, the random {it:ID#} assigned
to students. It may also contain other information (such as
email, major, real ID # used by the school, etc.) if this data existed
in the original file processed by {cmd:aisa roster}.
This file is created by {cmd:aisa roster}.

{phang}{cmd:aisa-}{it:project}{cmd:-grade.dta} contains student
names ({cmd:LastName} and {cmd:FirstName}), random IDs ({cmd:CourseID})
and the results ({it:assignment}{cmd:_RawScore}, {it:assignment}{cmd:_AdjScore}
and {it:assignment}{cmd:_Missed}) for each graded and {cmd:aisa update}d
assignment. This file is created by {cmd:aisa roster} and updated
by {cmd:aisa update}.

{phang}{cmd:data-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta} contains
data for individual student work on a given {it:assignment}. It is
created by the pair of {cmd:aisa data }{it:assignment} subcommand and
instructor's {cmd:data-}{it:assignment}{cmd:.do} in subdirectory
{it:assignment} and can be optionally written to an external folder
for immediate student access. The format of this file is free
and up to the instructor.

{phang}{cmd:key-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta} contains
the answer keys for a given {it:assignment}. It is
created by the pair of {cmd:aisa keys }{it:assignment} subcommand and
instructor's {cmd:key-}{it:assignment}{cmd:.do} in subdirectory
{it:assignment}. It contains variables {cmd:Question} (question
number), {cmd:Key} (the exact answer) and {cmd:Tolerance}
(the student answer is marked as correct if it is within
{cmd:Tolerance} of the {cmd:Key}). The subcommand {cmd:aisa check}
merges this file with student-submitted
{cmd:answers-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta} (see next entry).

{phang}{cmd:answers-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta}
is to be created by the students. It must contain variables
{cmd:Question} and {cmd:Answer}. That's what {cmd:aisa check}
is looking for, and gives an error message if those variables
are not found.

{phang}{cmd:result-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta}
is produced by {cmd:aisa check} {it:assignment ID#}. It contains variables
{cmd:CourseID} (student {it:ID#}),
{cmd:Question} and {cmd:Answer} taken from the student's submission
({cmd:answers-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta}),
a binary indicator of whether the question was answered correctly
{cmd:Correct},
and the overall assessment results
{cmd:RawScore}, {cmd:AdjScore} (expressed on American scale from 0 to 100)
and {cmd:Missed} containing the list of questions that were not answered
correctly. The latter three variables are added to
{it:project}{cmd:-grades.dta} file by {cmd:aisa update}.


Do-files:

{phang}{cmd:data-}{it:assignment}{cmd:.do} is the file created
by the instructor and placed in {it:assignment} directory.
{cmd:aisa data} will set the seed to the
student {it:ID#} before running this file, and will save
whatever is left in memory as
{cmd:data-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta}.
It is the instructor's responsibility (and creativity) to
simulate the necessary data. See {help aisa##examples:Examples}
below.

{phang}{cmd:key-}{it:assignment}{cmd:.do} is the file created
by the instructor and placed in {it:assignment} directory.
The file {cmd:data-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta}
is preloaded, and the instructor's key will be
{help post}ed to the {help postfile} {cmd:AISA_post}.
The latter is defined by

{phang2}{cmd:postfile AISA_post Question Key Tolerance using key-}{it:assignment}{cmd:-}{it:ID#}

{phang}See {help aisa##examples:Examples} below.

{phang}{it:assignment}{cmd:-}{it:ID#}{cmd:.do} are student submissions.
They are expected to create {cmd:answers-}{it:assignment}{cmd:-}{it:ID#}{cmd:.dta},
which is usually achieved either by direct {help input} or by
{help post} mechanism.


{title:Error messages and exceptions}

{pstd}
{cmd:aisa} tries to {help capture} all the file operations
and some of the variable manipulations. When working with individual
assignments, it descends into {it:assignment} subdirectories,
and in (rare) cases of uncaptured errors (such as user initiated
-Break-), it will end up in the wrong current directory.

{pstd}
The very first thing executed by {cmd:aisa} is to load
{cmd:aisa.dta} file in the current directory and use the
characteristics defined in it, such as the project name.
If loading this file fails, the error message is issued:

{phang2} {err:No AISA files found, may be you are in a wrong directory, or have not defined any projects yet}{p_end}
{phang2}
{search r(601);}

{pstd}The most frequent reason for this message is that {cmd:aisa data},
{cmd:aisa keys}, {cmd:aisa check} or {cmd:aisa update} make a recursion
to a subdirectory and failed to come back up.

{pstd}The errors that are likely to be produced by {cmd:aisa data}
and {cmd:aisa keys} are the ``substantive'' error messages when
things go wrong with the corresponding data files.
The instructor must attend to these error messages to the best of
his or her Stata knowledge!

{pstd}A number of error messages can be issued by {cmd:aisa check}. The fatal problems are:

{phang2}{err:Error: submission from student # ****** not found}

{pstd}This error message indicates that {cmd:aisa check} did not find
the file {cmd:answers-}{it:assignment}{cmd:-}{it:ID#}{cmd.dta},
or this file was unreadable.

{phang2}{err:Error: variables Question and Answer not found in student # ****** submission}

{pstd}This error message indicates that although {cmd:aisa check} found
the file {cmd:answers-}{it:assignment}{cmd:-}{it:ID#}{cmd.dta},
it did not contain the variables it was looking for. The two predominant
causes are (i) the student typed {cmd:question} and {cmd:answer} in lower
case for the name variables ({cmd:aisa} does not try to look for that
and fix it), or (ii) the student accidentally overwritten the
file {cmd:answers-}{it:assignment}{cmd:-}{it:ID#}{cmd.dta} with the original
data file {cmd:data-}{it:assignment}{cmd:-}{it:ID#}{cmd.dta}.

{pstd}In some cases, {cmd:aisa check} will notify the instructor of minor
problems it could overcome.
The following warnings are produced based on verifying the results of the
{help merge} of {cmd:answers-}{it:assignment}{cmd:-}{it:ID#}{cmd.dta}
and {cmd:key-}{it:assignment}{cmd:-}{it:ID#}{cmd.dta}.

{phang2}{err:Warning: multiple answers received from student # ******}

{pstd}This happens when some questions are repeated more than once in
{cmd:answers-}{it:assignment}{cmd:-}{it:ID#}{cmd.dta} when the student
forgets to update the number of the question they are answering. If this
happens for every student, then it was the instructor who forgot to update
that number in their keys! In case of this warning, {cmd:aisa check}
drops all the entries, as it has no way of determining which was the intended one.

{phang2}{err:Warning: answers from student # 273012 are not matching up}

{pstd}This error message is produced when some of the questions were not
answered by the student, so that there were underutilized question numbers
from {cmd:key-}{it:assignment}{cmd:-}{it:ID#}{cmd.dta}.

{pstd}If there were no problems, or warnings only, {cmd:aisa check} will output

{phang2}Student # ****** data responses processed successfully.


{title:Examples}{marker examples}


{title:Notes}

{pstd}To run the first {cmd:aisa roster} command, the list of students
must already be prepared and made relatively easily available in
the {it:using} file. The AI of {cmd:aisa roster} is limited to the files
that can be read by {help use} or {help infile} command. As the instructor
is expected to be proficient in Stata, preparing the data for reading
should not be a problem.

{pstd}Generally speaking, {cmd:aisa} is extremely picky to the misspelled
variable or file names. The instructor must make sure that the instructions
to students are extremely clear and specific.


{title:Author}

Stanislav Kolenikov, skolenik at gmail dot com


{title:Also see}

{psee}Help for {help post}.
